/*  atenea
 *  Copyright (C) 1999 <ryu@mundivia.es>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include "rules.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

Rule *rule_new(GList *condiciones, GList *frases, GList *siempre)
{
  Rule *retorno=(Rule *)malloc(sizeof(Rule));
  
  retorno->condiciones=condiciones;
  retorno->frases=frases;
  retorno->siempre=siempre;
  
  return retorno;
}

int find(char *s, GList *wordlist)
{
  GList *index=wordlist;
  while(index)
    {
    if (strstr(s,(char *)index->data)==NULL) return 0;
    index=index->next;
    }
return 1;
}

int check_rule(char *s, Rule *r)
{
  GList *index=r->condiciones;
  
  while (index)
    {
    if (find(s,(GList *)index->data)) return 1;
    index=index->next;
    }
return 0;
}

char *rnd_select(GList *frases)
{
  int num=g_list_length(frases);
  int valid=(int)(1.0*rand()*num/(RAND_MAX+1.0));
  return (char *)g_list_nth_data(frases,valid);
}

GList *dup_list(GList *l)
{
  GList *ret=NULL;
  while(l)
    {
      ret=g_list_append(ret,l->data);
      l=l->next;
    }
  return ret;
}

GList *atenea_say(char *orig, GList *rules, GList *defecto)
{
  GList *index=rules;
  while (index)
    {
      Rule *rule=(Rule *)index->data;
      if (check_rule(orig,rule))
         return g_list_concat(dup_list(rule->siempre),g_list_append(NULL,rnd_select(rule->frases)));
      index=index->next;
    }
return g_list_append(NULL,rnd_select(defecto));
}

